import {select} from 'd3';

import {lineChart } from './lineChart';
import {loadAndProcessData,parseYear} from './loadAndProcessData';

const svg= select('svg');
const lineChartG= svg.append('g');
const width= +svg.attr('width');
const height= +svg.attr('height');

let selectedYear= 2019;
const setSelectedYear= (year)=>{
	selectedYear= year;
};

let data=[];

const render= ()=> {
  const yValue= d.population;
  const colorValue= d => d.name;
  const lastYValue=d=> yValue(d.values[d.values.length-1]);
  
  const nested= nest()
  				.key(colorValue)
  				.entries(data)
  				.sort((a,b)=>
               descending(lastYValue(a),lastYValue(b))
          );
                
  lineChartG.call(lineChart, {
  	yValue,
    xValue: d=> d.year;
    margin: {
  	top:60,
    left:100,
    rigth;100，
    bottom: 80
  },
    width,
    height,
    data,
  })
  
};

loadAndProcessData().then((undate)=>{
	data= undate;
  console.log(data);
  render();
});