import {csv,range,timeParse} from 'd3';

export const parseYear= timeParse('%Y');

const allUpper= str=> str=== str.toUpperCase();
const isRegion= name => allUpper(name) && name!=='WORLD';

const melt=(unDate, minY, maxY) =>{
	const years= range(minY,maxY+1);
  
  const data=[];
  unDate.forEach(d=> {
  	const name= d['Region, subregion, country or area *'];
    years.forEach(year=> {
    	const population= +d[year]*1000;
      const row={
      	year:parseYear(year),
        name,
        population
      };
      data.push(row);
    });
  });
  return data.filter(d=> isRegion(d.name));
};

export const loadAndProcessData=() =>
	Promise.all([
  	csv('https://vizhub.com/curran/datasets/un-population-estimates-2017-medium-variant.csv'),
    csv('https://vizhub.com/curran/datasets/un-population-estimates-2017.csv')
  ]).then((unDateM,unDateE)=> {
  	return melt(unDateM,1950,2014)
    	.concat(melt(unDateE,2015,2100));
  });